//      MHlist v1.0			Segment 3
//
//		RES_UTIL.CPP		Utility fct's for dealing w/resources
//
//		(C)opyright 1992	by Matthias Hansen. Alle Rechte vorbehalten.
//
//
#pragma  option -zC_TEXT_ABOUT
#include "mhlist.h"
#pragma  hdrstop

// ----mh_MakeResStr----------------------------Convert MakeIntRes'ed string to real string---

void _EXPFUNC _FAR mh_MakeResStr( const char *ResString, char *Buffer, int BufSize )
{

	//	Is this MakeIntRes'ed ?
	// 
	if ( SELECTOROF( (LONG)ResString ) == 0 ) {

		//	Yes, convert number to text
		// 
		itoa( OFFSETOF( (LONG)ResString ), Buffer, 10 );

		}
	else {

		strncpy( Buffer, ResString, --BufSize );
		Buffer [ BufSize ] = 0;

        }

}

// ----mh_ResourceText(PTStatic)--------------------------------------------------------------- 

void _EXPFUNC _FAR mh_ResourceText( PTStatic Control, ... )
{
	va_list 			arg_ptr;
	char				Format[ 120 ],	//	Format string
						Buffer[ 200 ];	//	Output


	//	Retrieve text
	//
	Control->GetText( Format, sizeof(Format) );

	//	Create string
	//
	va_start( arg_ptr, Control );
	vsprintf( Buffer , Format , arg_ptr );
	va_end  ( arg_ptr );

	//	Set text
    //
	Control->SetText( Buffer );

}

// ----mh_ResourceText(PTWindowsObject)--------------------------------------------------------

void _EXPFUNC _FAR mh_ResourceText( PTWindowsObject Window, ... )
{
	va_list 			arg_ptr;
	char				Buffer[ 120 ];	//	Output


	//	Check title
	//
	if ( !Window->Title || (LONG)Window->Title == 0x0000FFFF )
    	return;
    	

	//	Create string
	//
	va_start( arg_ptr, Window );
	vsprintf( Buffer , Window->Title, arg_ptr );
	va_end  ( arg_ptr );

	//	Set text
    //
	Window->SetCaption( Buffer );

}

// ----eof RES_UTIL.CPP-----------------------------------------------------------------------